#ifndef GABA_DEFINE
struct logout_cleanup
{
  struct exit_callback super;
  struct resource *process;
  struct utmp (*(log));
  struct exit_callback *c;
};
extern struct lsh_class logout_cleanup_class;
#endif /* !GABA_DEFINE */

#ifndef GABA_DECLARE
static void do_logout_cleanup_mark(struct lsh_object *o, 
void (*mark)(struct lsh_object *o))
{
  struct logout_cleanup *i = (struct logout_cleanup *) o;
  mark((struct lsh_object *) i->process);
  mark((struct lsh_object *) i->c);
}

static void do_logout_cleanup_free(struct lsh_object *o)
{
  struct logout_cleanup *i = (struct logout_cleanup *) o;
  lsh_space_free(i->log);
}

struct lsh_class logout_cleanup_class =
{ STATIC_HEADER,
  &exit_callback_class, "logout_cleanup", sizeof(struct logout_cleanup),
  do_logout_cleanup_mark,
  do_logout_cleanup_free
};
#endif /* !GABA_DECLARE */

#ifndef GABA_DEFINE
struct process_resource
{
  struct resource super;
  pid_t pid;
  int signal;
};
extern struct lsh_class process_resource_class;
#endif /* !GABA_DEFINE */

#ifndef GABA_DECLARE
struct lsh_class process_resource_class =
{ STATIC_HEADER,
  &resource_class, "process_resource", sizeof(struct process_resource),
  NULL,
  NULL
};
#endif /* !GABA_DECLARE */

#ifndef GABA_DEFINE
struct unix_user
{
  struct lsh_user super;
  gid_t gid;
  struct lsh_string *passwd;
  struct lsh_string *home;
  struct lsh_string *shell;
};
extern struct lsh_class unix_user_class;
#endif /* !GABA_DEFINE */

#ifndef GABA_DECLARE
static void do_unix_user_free(struct lsh_object *o)
{
  struct unix_user *i = (struct unix_user *) o;
  lsh_string_free(i->passwd);
  lsh_string_free(i->home);
  lsh_string_free(i->shell);
}

struct lsh_class unix_user_class =
{ STATIC_HEADER,
  &lsh_user_class, "unix_user", sizeof(struct unix_user),
  NULL,
  do_unix_user_free
};
#endif /* !GABA_DECLARE */

#ifndef GABA_DEFINE
struct unix_user_db
{
  struct user_db super;
  int allow_root;
};
extern struct lsh_class unix_user_db_class;
#endif /* !GABA_DEFINE */

#ifndef GABA_DECLARE
struct lsh_class unix_user_db_class =
{ STATIC_HEADER,
  &user_db_class, "unix_user_db", sizeof(struct unix_user_db),
  NULL,
  NULL
};
#endif /* !GABA_DECLARE */

